using System;
using System.Collections.Specialized;
using System.IO;
using System.Text;

namespace ExtendReplacer
{
	/// <summary>
	/// ExtendReplacer ̊Tv̐łB
	/// </summary>
	public class ExtendReplacer
	{
		private string InnerReplaceFilePath = string.Empty;
		private string InnerDefineFilePath = string.Empty;
		private bool InnerIsRevers = false;
		private string InnerErrorMessage = string.Empty;
		private Encoding InnerReplaceFileEncoding = Encoding.Default;
		private Encoding InnerDefineFileEncoding = Encoding.Default;
		
		#region public ExtendReplacer(string replaceFilePath, string defineFilePath)
		/// <summary>
		///		<see cref="ExtendReplacer"/> NXRXgN^B
		/// </summary>
		/// <param name="replaceFilePath">uΏۃt@CpX</param>
		/// <param name="defineFilePath">u`t@CpX</param>
		public ExtendReplacer(string replaceFilePath, string defineFilePath)
		{
			InnerReplaceFilePath = replaceFilePath;
			InnerDefineFilePath = defineFilePath;
		}
		#endregion
		
		#region public ExtendReplacer(string replaceFilePath, string defineFilePath, bool isRevers)
		/// <summary>
		///		<see cref="ExtendReplacer"/> NXRXgN^B
		/// </summary>
		/// <param name="replaceFilePath">uΏۃt@CpX</param>
		/// <param name="defineFilePath">u`t@CpX</param>
		/// <param name="isRevers">utōs߂̃tO</param>
		public ExtendReplacer(string replaceFilePath, string defineFilePath, bool isRevers)
		{
			InnerReplaceFilePath = replaceFilePath;
			InnerDefineFilePath = defineFilePath;
			InnerIsRevers = isRevers;
		}
		#endregion
		
		#region public string ErrorMessage
		/// <summary>
		///		G[bZ[WvpeBB擾̂݉\
		/// </summary>
		public string ErrorMessage
		{
			get
			{
				return this.InnerErrorMessage;
			}
		}
		#endregion
		
		#region public Encoding ReplaceFileEncoding
		/// <summary>
		///		uΏۃt@C̃GR[fBO
		/// </summary>
		public Encoding ReplaceFileEncoding
		{
			get
			{
				return this.InnerReplaceFileEncoding;
			}
			set
			{
				this.InnerReplaceFileEncoding = value;
			}
		}
		#endregion
		
		#region public Encoding DefineFileEncoding
		/// <summary>
		///		`t@C̃GR[fBO
		/// </summary>
		public Encoding DefineFileEncoding
		{
			get
			{
				return this.InnerDefineFileEncoding;
			}
			set
			{
				this.InnerDefineFileEncoding = value;
			}
		}
		#endregion
		
		#region public void Replace()
		/// <summary>
		///		u
		/// </summary>
		public void Replace()
		{
			if (!File.Exists(this.InnerReplaceFilePath) || !File.Exists(this.InnerDefineFilePath))
			{
				return;
			}
			
			try
			{
				// uf[^i[pϐ`
				StringBuilder readData = new StringBuilder();
				
				// `t@Cǂݍ
				StringCollection searchStrings, replaceStrings;
				this.GetReplaceDefineCollection(out searchStrings, out replaceStrings);
				
				// uΏۃt@CJiǂݎ胂[hj
				#region uΏۃt@CJiǂݎ胂[hj
				StreamReader sr = new StreamReader(this.InnerReplaceFilePath, this.InnerReplaceFileEncoding);
				try
				{
					// Sǂݍ
					readData.Append(sr.ReadToEnd());
				
					// u
					#region u
					if (!InnerIsRevers)
					{
						for (int i = 0; i < searchStrings.Count; i++)
						{
							readData.Replace(searchStrings[i], replaceStrings[i]);
						}
					}
					else
					{
						for (int i = searchStrings.Count - 1; i >= 0; i--)
						{
							readData.Replace(searchStrings[i], replaceStrings[i]);
						}
					}
					#endregion
				}
				finally
				{
					// uΏۃt@C
					sr.Close();
				}
				#endregion
				
				// uΏۃt@CJi݃[hj
				#region uΏۃt@CJi݃[hj
				StreamWriter sw = new StreamWriter(this.InnerReplaceFilePath, false, this.InnerReplaceFileEncoding);
				try
				{
					// 
					sw.Write(readData.ToString());
					sw.Flush();
				}
				finally
				{
					// uΏۃt@C
					sw.Close();
				}
				#endregion
			}
			catch(Exception ex)
			{
				InnerErrorMessage = ex.Message;
			}
		}
		#endregion
		
		#region private void GetReplaceDefineCollection(out StringCollection searchStrings, out StringCollection replaceStrings)
		/// <summary>
		///		u`t@Cǂݍ݁A<see cref="StringCollection"/> Ɋi[܂B
		/// </summary>
		/// <param name="searchStrings">i[p <see cref="StringCollection"/></param>
		/// <param name="replaceStrings">ui[p <see cref="StringCollection"/></param>
		private void GetReplaceDefineCollection(out StringCollection searchStrings, out StringCollection replaceStrings)
		{
			// ߂l
			searchStrings = new StringCollection();
			replaceStrings = new StringCollection();
			
			if (File.Exists(this.InnerDefineFilePath))
			{
				System.IO.StreamReader sr = new StreamReader(this.InnerDefineFilePath, this.InnerDefineFileEncoding);
				
				string lineString = sr.ReadLine();
				while(lineString != null)
				{
					if (lineString.Length > 0 && lineString[0] != '#')
					{
						string[] splitData = lineString.Split('\t');
						
						if (splitData.Length >= 2)
						{
							if (!InnerIsRevers)
							{
								searchStrings.Add(splitData[0].Replace("\\\\TAB\\\\", "\t").Replace("\\\\CR\\\\", "\r").Replace("\\\\LF\\\\", "\n"));
								replaceStrings.Add(splitData[1].Replace("\\\\TAB\\\\", "\t").Replace("\\\\CR\\\\", "\r").Replace("\\\\LF\\\\", "\n"));
							}
							else
							{
								searchStrings.Add(splitData[1].Replace("\\\\TAB\\\\", "\t").Replace("\\\\CR\\\\", "\r").Replace("\\\\LF\\\\", "\n"));
								replaceStrings.Add(splitData[0].Replace("\\\\TAB\\\\", "\t").Replace("\\\\CR\\\\", "\r").Replace("\\\\LF\\\\", "\n"));
							}
						}
					}
					
					lineString = sr.ReadLine();
				}
				
				sr.Close();
			}
		}
		#endregion
	}
}
